import { FigmaElement } from '../../contracts/FigmaElement';
import { FRAME as Frame } from '../../contracts/Figma';
import { Config } from '../../contracts/Config';
export declare const makeFigmagicElement: (element: FigmaElement, config: Config, description?: string, isGraphicElement?: boolean) => FigmagicElement;
declare class FigmagicElement {
    id: string;
    name: string;
    children?: Frame[];
    type: string;
    isGraphicElement: boolean;
    config: Config;
    description: string;
    element: string;
    css: string;
    html: string;
    extraProps: string;
    text: string | undefined;
    imports: string[];
    constructor(element: FigmaElement, config: Config, description: string | undefined, isGraphicElement: boolean);
    init(): void;
    private handleElements;
    private setCss;
    private replaceHtml;
    private addExtraProps;
    private setText;
    private setElement;
    private setDescription;
    private setPlaceholderText;
    private setElementType;
    private handleNestedElements;
    private handleFlatElements;
    private parseNestedCss;
    private parseFlatCss;
    private processFlatCss;
}
export {};
